#extension GL_OES_EGL_image_external : require

precision mediump float;

uniform samplerExternalOES u_Texture;
uniform sampler2D camera_Texture;

varying vec2 v_TexCoordinate;
varying vec2 v_BgTexCoordinate;


uniform  vec2 singleStepOffset;
uniform  vec4 params;
uniform  float brightness;
uniform  float filter_level;

uniform sampler2D filter_Texture;

const  vec3 W = vec3(0.299, 0.587, 0.114);
const  mat3 saturateMatrix = mat3(
        1.1102, -0.0598, -0.061,
        -0.0774, 1.0826, -0.1186,
        -0.0228, -0.0228, 1.1772);
 vec2 blurCoordinates[24];

 float hardLight( float color) {
    if (color <= 0.5){
        color = color * color * 2.0;
    }
    else{
        color = 1.0 - ((1.0 - color)*(1.0 - color) * 2.0);
    }
    return color;
}

void main(){

                vec3 centralColor = texture2D(camera_Texture, v_BgTexCoordinate).rgb;
                blurCoordinates[0] = v_BgTexCoordinate.xy + singleStepOffset * vec2(0.0, -10.0);
                blurCoordinates[1] = v_BgTexCoordinate.xy + singleStepOffset * vec2(0.0, 10.0);
                blurCoordinates[2] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-10.0, 0.0);
                blurCoordinates[3] = v_BgTexCoordinate.xy + singleStepOffset * vec2(10.0, 0.0);
                blurCoordinates[4] = v_BgTexCoordinate.xy + singleStepOffset * vec2(5.0, -8.0);
                blurCoordinates[5] = v_BgTexCoordinate.xy + singleStepOffset * vec2(5.0, 8.0);
                blurCoordinates[6] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-5.0, 8.0);
                blurCoordinates[7] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-5.0, -8.0);
                blurCoordinates[8] = v_BgTexCoordinate.xy + singleStepOffset * vec2(8.0, -5.0);
                blurCoordinates[9] = v_BgTexCoordinate.xy + singleStepOffset * vec2(8.0, 5.0);
                blurCoordinates[10] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-8.0, 5.0);
                blurCoordinates[11] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-8.0, -5.0);
                blurCoordinates[12] = v_BgTexCoordinate.xy + singleStepOffset * vec2(0.0, -6.0);
                blurCoordinates[13] = v_BgTexCoordinate.xy + singleStepOffset * vec2(0.0, 6.0);
                blurCoordinates[14] = v_BgTexCoordinate.xy + singleStepOffset * vec2(6.0, 0.0);
                blurCoordinates[15] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-6.0, 0.0);
                blurCoordinates[16] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-4.0, -4.0);
                blurCoordinates[17] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-4.0, 4.0);
                blurCoordinates[18] = v_BgTexCoordinate.xy + singleStepOffset * vec2(4.0, -4.0);
                blurCoordinates[19] = v_BgTexCoordinate.xy + singleStepOffset * vec2(4.0, 4.0);
                blurCoordinates[20] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-2.0, -2.0);
                blurCoordinates[21] = v_BgTexCoordinate.xy + singleStepOffset * vec2(-2.0, 2.0);
                blurCoordinates[22] = v_BgTexCoordinate.xy + singleStepOffset * vec2(2.0, -2.0);
                blurCoordinates[23] = v_BgTexCoordinate.xy + singleStepOffset * vec2(2.0, 2.0);

                 float sampleColor = centralColor.g * 22.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[0]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[1]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[2]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[3]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[4]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[5]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[6]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[7]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[8]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[9]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[10]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[11]).g;
                sampleColor += texture2D(camera_Texture, blurCoordinates[12]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[13]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[14]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[15]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[16]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[17]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[18]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[19]).g * 2.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[20]).g * 3.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[21]).g * 3.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[22]).g * 3.0;
                sampleColor += texture2D(camera_Texture, blurCoordinates[23]).g * 3.0;

                sampleColor = sampleColor / 62.0;

                 float highPass = centralColor.g - sampleColor + 0.5;

                for (int i = 0; i < 5; i++) {
                    highPass = hardLight(highPass);
                }
                 float lumance = dot(centralColor, W);

                 float alpha = pow(lumance, params.r);

                 vec3 smoothColor = centralColor + (centralColor-vec3(highPass))*alpha*0.1;

                smoothColor.r = clamp(pow(smoothColor.r, params.g), 0.0, 1.0);
                smoothColor.g = clamp(pow(smoothColor.g, params.g), 0.0, 1.0);
                smoothColor.b = clamp(pow(smoothColor.b, params.g), 0.0, 1.0);

                 vec3 lvse = vec3(1.0)-(vec3(1.0)-smoothColor)*(vec3(1.0)-centralColor);
                 vec3 bianliang = max(smoothColor, centralColor);
                 vec3 rouguang = 2.0*centralColor*smoothColor + centralColor*centralColor - 2.0*centralColor*centralColor*smoothColor;

                gl_FragColor = vec4(mix(centralColor, lvse, alpha), 1.0);
                gl_FragColor.rgb = mix(gl_FragColor.rgb, bianliang, alpha);
                gl_FragColor.rgb = mix(gl_FragColor.rgb, rouguang, params.b);

                 vec3 satcolor = gl_FragColor.rgb * saturateMatrix;
                gl_FragColor.rgb = mix(gl_FragColor.rgb, satcolor, params.a);
                gl_FragColor.rgb = vec3(gl_FragColor.rgb + vec3(brightness));

              vec4 videoColor = texture2D(u_Texture, v_BgTexCoordinate);
              vec4 cameraColor = texture2D(camera_Texture, v_BgTexCoordinate);

                vec4 middelColor = mix(videoColor,gl_FragColor,cameraColor.a);
              //gl_FragColor = videoColor;
                  //clamp一下
                  vec4 textureColor=clamp(middelColor, vec4(0,0,0,0), vec4(1,1,1,1));
                //滤镜
                  float blueColor = textureColor.b * 63.0;
                  vec2 quad1;
                  quad1.y = floor(floor(blueColor) / 8.0);
                  quad1.x = floor(blueColor) - (quad1.y * 8.0);

                  vec2 quad2;
                  quad2.y = floor(ceil(blueColor) / 8.0);
                  quad2.x = ceil(blueColor) - (quad2.y * 8.0);

                  vec2 texPos1;
                  texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
                  texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

                  vec2 texPos2;
                  texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
                  texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

                  vec4 newColor1 = texture2D(filter_Texture, texPos1);
                  vec4 newColor2 = texture2D(filter_Texture, texPos2);

                  vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
                  gl_FragColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), filter_level); //这里的1.0可以换成一个变量，用来调节滤镜融合多少，0.0是原图，1.0是滤镜百分百。
 }

