
#extension GL_OES_EGL_image_external : require
precision mediump float;
uniform sampler2D u_Texture;
uniform sampler2D lut_Texture;
varying vec2 v_TexCoordinate;
uniform  float filter_level;
void main()
{
    vec4 textureColor = texture2D(u_Texture, v_TexCoordinate);
    float blueColor = textureColor.b * 63.0;
    vec2 quad1;
    quad1.y = floor(floor(blueColor) / 8.0);
    quad1.x = floor(blueColor) - (quad1.y * 8.0);
    vec2 quad2;
    quad2.y = floor(ceil(blueColor) / 8.0);
    quad2.x = ceil(blueColor) - (quad2.y * 8.0);
    vec2 texPos1;
    texPos1.x = (quad1.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos1.y = (quad1.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

    vec2 texPos2;
    texPos2.x = (quad2.x * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.r);
    texPos2.y = (quad2.y * 0.125) + 0.5/512.0 + ((0.125 - 1.0/512.0) * textureColor.g);

    vec4 newColor1 = texture2D(lut_Texture, texPos1);
    vec4 newColor2 = texture2D(lut_Texture, texPos2);

    vec4 newColor = mix(newColor1, newColor2, fract(blueColor));
    gl_FragColor = mix(textureColor, vec4(newColor.rgb, textureColor.w), filter_level); //这里的1.0可以换成一个变量，用来调节滤镜融合多少，0.0是原图，1.0是滤镜百分百。

    //gl_FragColor = videoColor;
}